/*
 * Problem    : crisis
 * Author     : Daniel Neiter
 * Language   : C++
 * Compiler   : MS Visual C++ 2008 Express Edition
 * Algorithm  : Brutforce backtracking algo
 * Complexity : O(2^N) 
 */

#include <cstdio>
#include <fstream>
#include <cassert>

using namespace std;

const char *infile="crisis.dat";
const char *outfile="crisis.sol";

const int maxN=50;

int lr[maxN];
int ur[maxN];
int n;
long long max_profit;

void solve(int i,long long olimp,long long galact) {
     if(i==n) {
          if(galact==0&&olimp>max_profit)
               max_profit=olimp;
     }
     else {
          solve(i+1,olimp,galact);   // do nothing
          if(galact)solve(i+1,olimp+lr[i]*galact,0);                 // sell galacts
          if(olimp>=ur[i]&&galact==0)solve(i+1,olimp%ur[i],galact+olimp/ur[i]); // buy galacts
     }
}

int main() {
     int i;
     int s;
     FILE *ifs=fopen(infile,"r");
     ofstream ofs(outfile);

     fscanf(ifs,"%d%d",&n,&s);
     for(i=0;i<n;i++) 
          fscanf(ifs,"%d%d",&ur[i],&lr[i]);

     max_profit=0;
     solve(0,s,0);

     ofs<<max_profit<<endl;

     fclose(ifs);
     return 0;
}
