/*
   Solution for pairs based on hungarian algo
   Complexity: O(N^3)
   Expected score: 20

   Written by Yaroslav Tverdokhlib
*/
#define _CRT_SECURE_NO_DEPRECATE
#include <algorithm>
#include <iostream>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <sstream>
#include <fstream>
#include <cstring>
using namespace std;
#define mp make_pair
#define x first
#define y second
#define pii pair<int,int>
#define INF 1000000000
#define FOR(i,a,b) for (int _n(b), i(a); i <= _n; i++)
#define FORD(i,a,b) for(int i=(a),_b=(b);i>=_b;i--)
#define all(c) (c).begin(), (c).end()
#define SORT(c) sort(all(c))
#define rep(i,n) FOR(i,1,(n))
#define rept(i,n) FOR(i,0,(n)-1)
#define C(a) memset((a),0,sizeof(a))
#define ll long long
int a,b,c,d,i,j,n,m,k,kolt;
double mas[2501][2501];
pii red[2501],blue[2501];
bool used[2501],used2[2501];
int lp[2501],q[2501];
#define eps 1e-7
bool dfs(int v)
{
	if (used[v]) return 0;
	used[v]=1;
	for (int w=0;w<n;++w)
	{
		if (abs(mas[v][w])<eps)
		{
			used2[w]=1;
			if (q[w]==-1 || dfs(q[w]))
			{
				lp[v]=w;
				q[w]=v;
				return 1;
			}
		}
	}
	return 0;
}
inline void match()
{
	bool ok=1;
	while (ok)
	{
		ok=0;
		memset(used,0,n);
		memset(used2,0,n);
		rept(i,n)
		{
			if (lp[i]==-1 && dfs(i)) ok=1;
		}
		if (!ok) break;
	}
}
int main()
{
	freopen("pairs.dat","r",stdin);
	freopen("pairs.sol","w",stdout);
	scanf("%d",&kolt);
	rep(hod,kolt)
	{
		scanf("%d",&n);
		rept(i,n)
		{
			scanf("%d%d",&blue[i].x,&blue[i].y);
		}
		rept(i,n)
		{
			scanf("%d%d",&red[i].x,&red[i].y);
		}
		memset(lp,-1,sizeof(lp));
		memset(q,-1,sizeof(q));
		rept(i,n)
		{
			rept(j,n)
			{
				mas[i][j]=sqrt((double)(blue[i].x-red[j].x)*(blue[i].x-red[j].x)+(double)(blue[i].y-red[j].y)*(blue[i].y-red[j].y));
			}
		}
		rept(i,n)
		{
			double a=INF;
			rept(j,n)
			{
				if (mas[i][j]<a) a=mas[i][j];
			}
			if (abs(a)<eps) continue;
			rept(j,n)
			{
				mas[i][j]-=a;
			}
		}
		rept(j,n)
		{
			double a=INF;
			rept(i,n)
			{
				if (mas[i][j]<a) a=mas[i][j];
			}
			if (abs(a)<eps) continue;
			rept(i,n)
			{
				mas[i][j]-=a;
			}
		}
		match();
		b=0;
		rept(i,n) if (lp[i]!=-1) ++b;
		bool ok=1;
		c=0;
		while (1)
		{
			ok=0;
			C(used); C(used2);
			while (c<n && lp[c]!=-1) ++c;
			if (c==n) break;
			if (dfs(c))
			{
				++b;
				continue;
			}
			double a=INF;
			rept(i,n)
			{
				if (used[i]) rept(j,n) if (!used2[j] && mas[i][j]<a) a=mas[i][j];
			}
			rept(i,n)
			{
				rept(j,n)
				{
					if (used[i] && !used2[j]) mas[i][j]-=a;
					if (!used[i] && used2[j]) mas[i][j]+=a;
				}
			}
			memset(used,0,n);
			if (dfs(c))
			{
				ok=1;
				++b;
			}
		}
		rept(i,n)
		{
			printf("%d %d\n",i+1,lp[i]+1);
		}
	}
}